Package: org.codehaus.groovy.classgen

## [Java] Class BytecodeExpression

- org.codehaus.groovy.classgen.BytecodeExpression

-     public abstract class BytecodeExpression
      extends Expression

  Represents some custom bytecode generation by the compiler.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static BytecodeExpression` | `NOP` | A no-operation bytecode expression that generates no instructions.

  - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class Expression` | `EMPTY_ARRAY`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `BytecodeExpression()` Creates a new bytecode expression.
    `BytecodeExpression(ClassNode type)` Creates a new bytecode expression with the specified type.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public String` | `getText()` * Returns a human-readable text representation of this AST node. * Used for debugging and error messages. Default implementation returns a message * indicating the representation is not yet implemented for this node type. * * Returns: text representation of this node, or placeholder for unimplemented types
    `` | `public Expression` | `transformExpression(ExpressionTransformer transformer)` * Transforms this expression and any nested expressions according to the provided transformer. * This method is called during AST transformation phases and must recursively transform * any nested expressions to support full AST tree transformation. * * Parameters: `transformer` - the ExpressionTransformer to apply * Returns: a transformed copy of this expression (or this expression itself if no changes are needed)
    `` | `public abstract void` | `visit(org.objectweb.asm.MethodVisitor visitor)` Emits bytecode instructions using the provided method visitor.
    `` | `public void` | `visit(GroovyCodeVisitor visitor)` * Accepts a code visitor for AST traversal and transformation. * Subclasses must implement this method to support visitor pattern-based processing. * The visitor pattern enables decoupling of AST structure from processing logic. * * throws: RuntimeException if visitor pattern support is not implemented for this node type Parameters: `visitor` - the GroovyCodeVisitor to process this node *

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Expression` | `getType, setType, transformExpression, transformExpressions, transformExpressions`
    `class AnnotatedNode` | `addAnnotation, addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, getGroovydoc, getInstance, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`
    `class ASTNode` | `copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getMetaDataMap, getText, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setMetaDataMap, setSourcePosition, visit`

- - ### Field Detail

    - #### public static final BytecodeExpression NOP

      A no-operation bytecode expression that generates no instructions.

  - ### Constructor Detail

    - #### public BytecodeExpression()

      Creates a new bytecode expression.

    - #### public BytecodeExpression(ClassNode type)

      Creates a new bytecode expression with the specified type.

      Parameters:
        `type` - the type of the expression

  - ### Method Detail

    - #### public String getText()

      * Returns a human-readable text representation of this AST node. * Used for debugging and error messages. Default implementation returns a message * indicating the representation is not yet implemented for this node type. * *

      Returns:
        text representation of this node, or placeholder for unimplemented types

    - #### public Expression transformExpression(ExpressionTransformer transformer)

      * Transforms this expression and any nested expressions according to the provided transformer. * This method is called during AST transformation phases and must recursively transform * any nested expressions to support full AST tree transformation. * *

      Parameters:
        `transformer` - the ExpressionTransformer to apply *
      Returns:
        a transformed copy of this expression (or this expression itself if no changes are needed)

    - #### public abstract void visit(org.objectweb.asm.MethodVisitor visitor)

      Emits bytecode instructions using the provided method visitor.

      Parameters:
        `visitor` - the ASM method visitor to generate bytecode

    - #### public void visit(GroovyCodeVisitor visitor)

      * Accepts a code visitor for AST traversal and transformation. * Subclasses must implement this method to support visitor pattern-based processing. * The visitor pattern enables decoupling of AST structure from processing logic. * *

      throws:
        RuntimeException if visitor pattern support is not implemented for this node type
      Parameters:
        `visitor` - the GroovyCodeVisitor to process this node *